extractdata_strips <-
function(workpath,substance,run,times,concentrations){#creates a function with the argument of workpath, Protein of interest and the calibration run

stoffcountingindex=1
daten=list()
for(substance in substance){


paths=Sys.glob(file.path(workpath, "*")) #creates a list of folders inheriting the timepointsorted data
paths=sort(paths)

a=list()  #creates empty table
b=list()  #creates empty table
neu=list()#creates empty table
foldernames=list.dir(path =paths[1])

progress=1
total=length(foldernames)*length(paths[-(1:3)])
bar=tkProgressBar(title = "This process could take several seconds", min = 0,max = total, width = 500)

for(j in foldernames){                        #first loop to go through the different folders of concentrations
m=1

for(i in paths[-(1:3)]){    

#create a progressbar object
setTkProgressBar(bar, progress, label=paste( "signal data exctraction",round(progress/total*100,0),"% done"))

#go through timepoints without the first three
a[[m]]=(read.table(paste(i,paste(j,"\\result.txt",sep=""),sep="\\"),header=T,sep="\t"))  #reading the tables and cut of unneccessary columns
a[[m]]=a[[m]][,-(c(which(colnames(a[[m]])=="Valid"),which(colnames(a[[m]])=="Background"),which(colnames(a[[m]])=="Mean")))]

analyte=(a[[m]][,2]==substance)

SpotIDs=c(a[[m]][analyte,"Spot.ID"])

a[[m]]=a[[m]][,-(c(which(colnames(a[[m]])=="Spot.ID")))]

a[[m]]=a[[m]][analyte,-(c(which(colnames(a[[m]])=="Confidence")))]


m=m+1
progress=progress+1
}

#go through all the columns an paste rows with equal names together in neu


for(g in 1:length(a[[m-1]][,1])){
neu[[g]]=a[[m-1]][g,]
for(l in 1:length(paths[-(1:3)])){
neu[[g]]=rbind(neu[[g]],a[[l]][g,])
}
neu[[g]]=neu[[g]][-(1),]
}

#whrite the different concentrations together in one list
b[[j]]=neu

}
#################################################################################################################################
#create table usable for plotting and analysis

d=list()  #create empty list

#seperate the list entries to the certain datasets

for(r in 1:length(b[[1]])){
d[[r]]=b[[1]][[r]][,1]
for(s in 1:length(foldernames)){
d[[r]]=cbind(d[[r]],b[[s]][[r]][,2])
}
d[[r]]=d[[r]][,-(1)]

#reflect the table and adjust it to rising concentrations

d[[r]]=arev(d[[r]],2)


}
#save data list, which inheritate the name of the analytes, the Spot IDs and the rawdata
daten[[stoffcountingindex]]=list("name"=substance,"concentrations"=concentrations,"times"=times,"SpotIDs"=SpotIDs,"rawdata"=d)
Blub=daten[[stoffcountingindex]]
#save(Blub,file=paste(substance,"rawdata",run,".RData",sep="_"))
stoffcountingindex=stoffcountingindex+1
close(bar)
}
return(daten)
}

